﻿''' <summary>
''' This control can edit the IObject list
''' </summary>
''' <remarks></remarks>
Public Class ucSetup

    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        Me.dg1.DataContext = Application.WorkList

        ' add the items to the datagrid 
        'ich hab mal auf ein aufwändiges Datagrid mit Bildern verzichtet aus Zeitgründen :-)
        For Each T As IObject In Application.ItemList
            Me.cmbAdd.Items.Add(T)
        Next
        Me.cmbAdd.SelectedItem = Me.cmbAdd.Items(0)
    End Sub


    Private Sub btnAdd_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles btnAdd.Click
        Dim item As IObject = Nothing

        Dim cF As New IOHandler
        item = cF.StringToIObject(CType(Me.cmbAdd.SelectedItem, IObject).Title)

        If item IsNot Nothing Then
            If TypeOf item Is clsStart Then
                For i As Integer = 0 To Application.WorkList.Count - 1
                    If TypeOf Application.WorkList(i) Is clsStart Then
                        Application.WorkList.RemoveAt(i)
                        Exit For
                    End If
                Next
            End If
            If TypeOf item Is clsEnd Then
                For i As Integer = 0 To Application.WorkList.Count - 1
                    If TypeOf Application.WorkList(i) Is clsEnd Then
                        Application.WorkList.RemoveAt(i)
                        Exit For
                    End If
                Next
            End If
            item.Index = Me.dg1.Items.Count
            Application.WorkList.Add(item)
        End If

        Call RefreshDg()
    End Sub

    Private Sub btnClear_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles btnClear.Click
        Application.WorkList.Clear()
        Call RefreshDg()
    End Sub

    Private Sub btnDelete_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles btnDelete.Click
        If Me.dg1.SelectedItem Is Nothing Then Exit Sub
        Application.WorkList.Remove(Me.dg1.SelectedItem)
        Call RefreshDg()
    End Sub

    Private Sub btnUp_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles btnUp.Click
        If Me.dg1.SelectedItem Is Nothing Then Exit Sub
        Dim item As IObject = Me.dg1.SelectedItem
        Dim Index As Integer = Me.dg1.SelectedIndex
        Application.WorkList.Remove(item)
        Application.WorkList.Insert(Math.Max(0, Index - 1), item)
        Call RefreshDg()
    End Sub

    Private Sub btnDown_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles btnDown.Click
        If Me.dg1.SelectedItem Is Nothing Then Exit Sub
        Dim item As IObject = Me.dg1.SelectedItem
        Dim Index As Integer = Me.dg1.SelectedIndex
        Application.WorkList.Remove(item)
        Application.WorkList.Insert(Math.Min(Me.dg1.Items.Count - 0, Index + 1), item)
        Call RefreshDg()
    End Sub

    Private Sub RefreshDg()
        Me.dg1.Items.Refresh()
    End Sub
End Class
