﻿''' <summary>
''' Interface to use all items
''' </summary>
''' <remarks></remarks>
Public Interface IObject
    Inherits IObjectBase
    ''' <summary>
    ''' On any dependency for next object, this object is not empty. Otherwise it is empty.
    ''' </summary>
    Property NeededNextObject As Type

    ' ''' <summary>
    ' ''' On any dependency for previous object, this object is not empty. Otherwise it is empty.
    ' ''' </summary>
    'Property NeededPreviousObject As Type

    ''' <summary>
    ''' The title of object
    ''' </summary>
    Property Title As String

    ''' <summary>
    ''' The position in Gui to draw
    ''' </summary>
    Property Location As Point

    ''' <summary>
    ''' Index of item
    ''' </summary>
    Property Index As Integer
    Sub Run()

End Interface

Public Interface IObjectBase
End Interface
